﻿/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.actionscript-facile.com
  Portions created by the Initial Developer are Copyright (C) 2010
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */
package
{
		

	import flash.events.IOErrorEvent;
	import com.actionscriptfacile.ui.text.UITextField;
	import flash.net.URLRequest;
	import flash.net.URLLoader;
	import flash.events.Event;
	import flash.display.Sprite;
	
	import com.demonsters.debugger.MonsterDebugger;


	public class Main extends Sprite
	{
		private var oTxtTitle : UITextField;
				
		/**
		 * Constructeur.
		 * 
		 */
		public function Main()
		{
			// attend la fin de l'initialisation de la scène
			this.addEventListener(Event.ADDED_TO_STAGE, onReady, false, 0, true);
		}

		/**
		 * Démarrage de l'application.
		 * définit le nombre d'images par secondes dans les paramètres de compilation
		 * -default-frame-rate 40
		 * 
		 */
		private function onReady(event : Event) : void
		{
			this.removeEventListener(Event.ADDED_TO_STAGE, onReady);

			// Init De MonsterDebugger
			MonsterDebugger.initialize(this);
			MonsterDebugger.trace(this, "Start Application");
			
			buildUI();
			// Objet URLLoader pour charger le contenu du flux RSS.
			var oXmlLoader : URLLoader = new URLLoader();
			oXmlLoader.addEventListener(Event.COMPLETE, onLoadComplete);
			oXmlLoader.addEventListener(IOErrorEvent.IO_ERROR, onLoadError);
			
			// lance le chargement du flux RSS
			oXmlLoader.load(new URLRequest('http://www.actionscript-facile.com/feed'));
		}


		/**
		 * Création de l'interface utilisateur.
		 * 
		 */
		private function buildUI() : void
		{
			oTxtTitle = new UITextField();
			oTxtTitle.x = 10;
			oTxtTitle.y = 10;
			oTxtTitle.htmlText = "Les derniers Cours AS3 sur <b><a href=\"http://www.actionscript-facile.com\">ActionScript Facile</a></b>" +
			"\n\n\n\n Chargement du Flux RSS ActionScript Facile en cours ...";
			oTxtTitle.selectable = false;
			oTxtTitle.width = stage.stageWidth;
			oTxtTitle.autoSizeCenter();
			oTxtTitle.alignCenter(); // centre le texte
			oTxtTitle.changeFormat("size", 14);// changement de la taille de la police du texte
			oTxtTitle.changeFormat("font", "Arial");// changement de la taille de la police du texte
			oTxtTitle.changeFormat("color", Math.random() * 0X00FFFFFF);// changement de la couleur
			this.addChild(oTxtTitle);
		}

		/**
		 * Chargement du fichier xml (flux rss) terminé.
		 * 
		 */
		private function onLoadComplete(event : Event) : void
		{
			MonsterDebugger.trace(this, "onLoadComplete");
			
			oTxtTitle.htmlText = "Les derniers Cours AS3 sur <b><a href=\"http://www.actionscript-facile.com\">ActionScript Facile</a></b>";
			
			var oContent:Sprite = new Sprite();
			oContent.x = 10;
			oContent.y = oTxtTitle.y + oTxtTitle.height + 10;
			
			// analyse le contenu du flux RSS
			var oXmlFeed : XML = new XML(event.target.data);
			
			// récupère le nombre d'items (les cours AS3) pour boucler dessus.
			var nbItems : int = oXmlFeed.channel.item.length();

			for (var i:int = 0; i < nbItems; i++)
			{
				// création  d'un objet Item
				var feedItem : Item = new Item(oXmlFeed.channel.item[i].title, 
												oXmlFeed.channel.item[i].link,
												stage.stageWidth - oContent.x*2);
				
				feedItem.y = (feedItem.height + 10) * i;// positionne les objets en liste
				oContent.addChild(feedItem);// ajoute l'objet à la liste d'affichage de la scène.
			}
			
			this.addChild(oContent);// affichage des boutons avec les liens vers les cours AS3
		}
		
		
		/**
		 * En cas d'erreur de chargement du flux RSS.
		 * Mobile connecté à internet ?
		 * 
		 */
		private function onLoadError(event : IOErrorEvent) : void
		{
			oTxtTitle.htmlText += "\n\nVérifiez votre connection internet !";
		}
		
		

	}
}
